<template>
  <div class="content">
    <b-container v-if="fullGames">
      <br>
        <h4 v-if="username">Bem-vindo (a) {{ username }}</h4>
      <br>

 
          <b-card>
            <template v-slot:header>
              <h5 class="mb-0"><b-icon icon="controller"/> Os meus jogos</h5>
            </template>
          <p>
            <button v-on:click="createGame" class="btn btn-success"><b-icon icon="plus"/> Criar Jogo</button>
          </p>

          
          <b-list-group v-if="games && games.length > 0">
              <b-list-group-item v-for="(game, index) in games" v-bind:key="index" class="d-flex justify-content-between align-items-center">
                <div>
                  <strong>Criado por: </strong><span>{{game.creator}} </span>
                  <strong>Estado: </strong><span>{{ printStatus(game.status) }} </span>
                  <strong>Data de Criação: </strong><span>{{new Date(game.createdAt).toLocaleDateString()}} {{new Date(game.createdAt).toLocaleTimeString()}}</span>
                </div>
                <div class="action-buttons">
                  <button v-on:click="deleteGame(game._id)" v-if="game.creator == username" class="btn btn-danger act-btn"><b-icon icon="trash"/></button>
                  <button v-on:click="playGame(game._id)" v-if="game.status == 'created' || game.status == 'playing'" class="btn btn-primary act-btn">Jogar</button>
                  <button v-on:click="playGame(game._id)" v-if="game.status == 'ended'" class="btn btn-primary act-btn">Ver</button>
                </div>
              </b-list-group-item>
          </b-list-group>
          <div v-else>
           <p class="text-center lead">Não possui jogos. Que tal criar um jogo?</p>
          </div>
            <div v-if="numOfPages > 1">
              <br>
              <p>Página {{currentPage}} de {{numOfPages}} </p>
              <div class="d-flex justify-content-center">
                <b-pagination
                  v-model="currentPage"
                  :total-rows="numOfGames"
                  :per-page="perPage"
                ></b-pagination>
              </div>
            </div>
          </b-card>
    </b-container>
    <br>    
  </div>

  
</template>

<style>


  .action-buttons button:not(:last-child){
    margin-right: 2px;
  }

  .act-btn {
    min-width: 64px;
  }


</style>

<script>
// @ is an alias to /src
//import HelloWorld from '@/components/HelloWorld.vue'

import GameService from '@/services/Game'
import UserService from '@/services/User'


export default {
  name: 'home',
  components: {
    
  },
  data () {
    return {
      username : null,
      fullGames: null,
      perPage: 10,
      currentPage: 1,
    }
  },
  computed : {
    games: function() {
      let initValue = (this.currentPage -1) * this.perPage;
      let lastValue = initValue + this.perPage;
      return this.fullGames.slice(initValue, lastValue );
    },
    numOfGames() {
      return this.fullGames.length;
    },
    numOfPages() {
      return Math.ceil(this.numOfGames / this.perPage);
    }
  },
  async mounted() {
    let user = await UserService.getUser();
    this.username = user.username;
    await this.listGames();


  },
  methods : {
    async listGames() {
       this.fullGames =  await GameService.getGames();
       if(this.fullGames) {
         this.fullGames.reverse();
       }
    },
    async deleteGame(id) {

      this.$bvModal.msgBoxConfirm('Tem a certeza que deseja remover o jogo?', {
          title: 'Remover jogo',
          size: 'md',
          buttonSize: 'md',
          okVariant: 'danger',
          okTitle: 'Remover',
          cancelTitle: 'Não',
          centered: true
      }).then( async (remove) => {
        if(remove) {
          await GameService.deleteGame(id);
          await this.listGames();
        }
      });
      
    },
    async createGame() {
      let data = await GameService.createGame();
      
      this.$router.push({ name: 'play', params: { gameId: data._id }})
    },
    playGame(id) {
      this.$router.push({ name: 'play', params: { gameId: id}})
    },
    printStatus(status) {
      if(status == "created") {
        return "Criado";
      } else if(status == "playing") {
        return "A Jogar";
      } else if(status == "ended") { 
        return "Terminado";
      } else {
        return "n/a";
      }
    }
  }
}
</script>
